/**
 * ngx-input-autocomplete - A angular 4+ directive for adding autocomplete functionality to text input elements, built around composability
 * @version v0.2.1
 * @author Matt Lewis
 * @link https://github.com/mattlewis92/angular-text-input-autocomplete#readme
 * @license MIT
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t(require("@angular/core"),require("@angular/common"),require("rxjs/add/operator/takeUntil"),require("rxjs/Subject")):"function"==typeof define&&define.amd?define(["@angular/core","@angular/common","rxjs/add/operator/takeUntil","rxjs/Subject"],t):"object"==typeof exports?exports.angularTextInputAutocomplete=t(require("@angular/core"),require("@angular/common"),require("rxjs/add/operator/takeUntil"),require("rxjs/Subject")):e.angularTextInputAutocomplete=t(e.ng.core,e.ng.common,e.Rx,e.Rx)}("undefined"!=typeof self?self:this,function(e,t,n,o){return function(e){function t(o){if(n[o])return n[o].exports;var i=n[o]={i:o,l:!1,exports:{}};return e[o].call(i.exports,i,i.exports,t),i.l=!0,i.exports}var n={};return t.m=e,t.c=n,t.d=function(e,n,o){t.o(e,n)||Object.defineProperty(e,n,{configurable:!1,enumerable:!0,get:o})},t.n=function(e){var n=e&&e.__esModule?function(){return e.default}:function(){return e};return t.d(n,"a",n),n},t.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},t.p="",t(t.s=2)}([function(t,n){t.exports=e},function(e,t,n){"use strict";var o=this&&this.__decorate||function(e,t,n,o){var i,r=arguments.length,c=r<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,n):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)c=Reflect.decorate(e,t,n,o);else for(var s=e.length-1;s>=0;s--)(i=e[s])&&(c=(r<3?i(c):r>3?i(t,n,c):i(t,n))||c);return r>3&&c&&Object.defineProperty(t,n,c),c},i=this&&this.__metadata||function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};Object.defineProperty(t,"__esModule",{value:!0});var r=n(0),c=n(8),s=function(){function e(){this.closeMenu=new r.EventEmitter,this.selectChoice=new c.Subject,this.choiceLoading=!1,this.startingY=0,this.endY=0,this.currentY=0,this.itemHeight=0,this.viewHeight=0}return Object.defineProperty(e.prototype,"choices",{get:function(){return this._choices},set:function(e){this._choices=e,-1===e.indexOf(this.activeChoice)&&e.length>0&&(this.activeChoice=e[1])},enumerable:!0,configurable:!0}),e.prototype.onArrowDown=function(e){e.preventDefault();var t=this.choices.indexOf(this.activeChoice);0===this.itemHeight&&this.dropdown.nativeElement.children[0]&&(this.itemHeight=this.dropdown.nativeElement.children[0].clientHeight,this.viewHeight=this.dropdown.nativeElement.clientHeight-3*this.itemHeight,this.currentY=-this.viewHeight),this.currentY+=this.itemHeight,(0===this.endY||this.currentY<this.endY)&&this.dropdown.nativeElement.scrollTo(0,this.currentY),this.choices[t+1]?this.choices[t+1].startsWith("---")?this.choices[t+2]&&(this.activeChoice=this._choices[t+2]):this.activeChoice=this._choices[t+1]:this.endY=this.currentY},e.prototype.onArrowUp=function(e){e.preventDefault();var t=this.choices.indexOf(this.activeChoice);0===this.itemHeight&&this.dropdown.nativeElement.children[0]&&(this.itemHeight=this.dropdown.nativeElement.children[0].clientHeight,this.viewHeight=this.dropdown.nativeElement.clientHeight-3*this.itemHeight),this.currentY<0?this.currentY=-this.viewHeight:(this.currentY-=this.itemHeight,this.dropdown.nativeElement.scrollTo(0,this.currentY)),this.choices[t-1]&&(this.choices[t-1].startsWith("---")?this.choices[t-2]&&(this.activeChoice=this._choices[t-2]):this.activeChoice=this._choices[t-1])},e.prototype.onEnter=function(e){this.choices.indexOf(this.activeChoice)>-1&&(e.preventDefault(),this.selectChoice.next(this.activeChoice))},e.prototype.onEscPress=function(e){this.closeMenu.emit()},o([r.ViewChild("inputACMenu"),i("design:type",r.ElementRef)],e.prototype,"dropdown",void 0),o([r.Output(),i("design:type",Object)],e.prototype,"closeMenu",void 0),o([r.HostListener("document:keydown.ArrowDown",["$event"]),i("design:type",Function),i("design:paramtypes",[KeyboardEvent]),i("design:returntype",void 0)],e.prototype,"onArrowDown",null),o([r.HostListener("document:keydown.ArrowUp",["$event"]),i("design:type",Function),i("design:paramtypes",[KeyboardEvent]),i("design:returntype",void 0)],e.prototype,"onArrowUp",null),o([r.HostListener("document:keydown.Enter",["$event"]),i("design:type",Function),i("design:paramtypes",[KeyboardEvent]),i("design:returntype",void 0)],e.prototype,"onEnter",null),o([r.HostListener("document:keydown.Escape",["$event"]),i("design:type",Function),i("design:paramtypes",[KeyboardEvent]),i("design:returntype",void 0)],e.prototype,"onEscPress",null),e=o([r.Component({template:'\n    <ul #inputACMenu\n      *ngIf="choices?.length > 0"\n      class="dropdown-menu"\n      [style.top.px]="position?.top"\n      [style.left.px]="position?.left">\n      <li \n        *ngFor="let choice of choices"\n        [ngStyle] = "{\'background-color\': choice.startsWith(\'---\') ? \'#E0EFF6\' : \'auto\', \n                    \'color\': choice.startsWith(\'---\') ? \'black\' : \'auto\'}"\n        [class.active]="activeChoice === choice">\n        <a\n          href="javascript:;"\n          (click)="selectChoice.next(choice)">\n          {{ choice }}\n        </a>\n      </li>\n    </ul>\n  ',styles:["\n    .dropdown-menu {\n      display: block;\n      overflow: auto;\n      height: 200px;\n      resize: both;\n    }\n  "]})],e)}();t.TextInputAutocompleteMenuComponent=s},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),function(e){for(var n in e)t.hasOwnProperty(n)||(t[n]=e[n])}(n(3));var o=n(1);t.TextInputAutocompleteMenuComponent=o.TextInputAutocompleteMenuComponent},function(e,t,n){"use strict";var o=this&&this.__decorate||function(e,t,n,o){var i,r=arguments.length,c=r<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,n):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)c=Reflect.decorate(e,t,n,o);else for(var s=e.length-1;s>=0;s--)(i=e[s])&&(c=(r<3?i(c):r>3?i(t,n,c):i(t,n))||c);return r>3&&c&&Object.defineProperty(t,n,c),c};Object.defineProperty(t,"__esModule",{value:!0});var i=n(0),r=n(4),c=n(5),s=n(9),u=n(1),p=function(){function e(){}return e=o([i.NgModule({declarations:[c.TextInputAutocompleteDirective,s.TextInputAutocompleteContainerComponent,u.TextInputAutocompleteMenuComponent],imports:[r.CommonModule],exports:[c.TextInputAutocompleteDirective,s.TextInputAutocompleteContainerComponent,u.TextInputAutocompleteMenuComponent],entryComponents:[u.TextInputAutocompleteMenuComponent]})],e)}();t.TextInputAutocompleteModule=p},function(e,n){e.exports=t},function(e,t,n){"use strict";var o=this&&this.__decorate||function(e,t,n,o){var i,r=arguments.length,c=r<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,n):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)c=Reflect.decorate(e,t,n,o);else for(var s=e.length-1;s>=0;s--)(i=e[s])&&(c=(r<3?i(c):r>3?i(t,n,c):i(t,n))||c);return r>3&&c&&Object.defineProperty(t,n,c),c},i=this&&this.__metadata||function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};Object.defineProperty(t,"__esModule",{value:!0});var r=n(0),c=n(6);n(7);var s=n(1),u=function(){function e(e,t,n,o){this.componentFactoryResolver=e,this.viewContainerRef=t,this.injector=n,this.elm=o,this.triggerCharacter="@",this.searchRegexp=/^\w*$/,this.menuComponent=s.TextInputAutocompleteMenuComponent,this.menuShown=new r.EventEmitter,this.menuHidden=new r.EventEmitter,this.choiceSelected=new r.EventEmitter,this.getChoiceLabel=function(e){return e}}return e.prototype.onKeypress=function(e){e.key===this.triggerCharacter&&this.showMenu()},e.prototype.onChange=function(e){var t=this;if(this.menu)if(e[this.menu.triggerCharacterPosition]!==this.triggerCharacter)this.hideMenu();else{var n=this.elm.nativeElement.selectionStart;if(n<this.menu.triggerCharacterPosition)this.hideMenu();else{var o=e.slice(this.menu.triggerCharacterPosition+1,n);o.match(this.searchRegexp)?(this.menu.component.instance.searchText=o,this.menu.component.instance.choices=[],this.menu.component.instance.choiceLoadError=void 0,this.menu.component.instance.choiceLoading=!0,this.menu.component.changeDetectorRef.detectChanges(),Promise.resolve(this.findChoices(o)).then(function(e){t.menu&&(t.menu.component.instance.choices=e,t.menu.component.instance.choiceLoading=!1,t.menu.component.changeDetectorRef.detectChanges())}).catch(function(e){t.menu&&(t.menu.component.instance.choiceLoading=!1,t.menu.component.instance.choiceLoadError=e,t.menu.component.changeDetectorRef.detectChanges())})):this.hideMenu()}}},e.prototype.onBlur=function(){this.menu&&(this.menu.lastCaretPosition=this.elm.nativeElement.selectionStart)},e.prototype.showMenu=function(){var e=this;if(!this.menu){var t=this.componentFactoryResolver.resolveComponentFactory(this.menuComponent);this.menu={component:this.viewContainerRef.createComponent(t,0,this.injector),triggerCharacterPosition:this.elm.nativeElement.selectionStart};var n=+getComputedStyle(this.elm.nativeElement).lineHeight.replace(/px$/,""),o=c(this.elm.nativeElement,this.elm.nativeElement.selectionStart),i=o.top,r=o.left;this.menu.component.instance.position={top:i+n,left:r},this.menu.component.changeDetectorRef.detectChanges(),this.menu.component.instance.closeMenu.subscribe(function(t){e.hideMenu()}),this.menu.component.instance.selectChoice.takeUntil(this.menuHidden).subscribe(function(t){var n=e.getChoiceLabel(t),o=e.elm.nativeElement,i=o.value,r=e.menu.triggerCharacterPosition,c=i.slice(0,r),s=e.menu.lastCaretPosition||o.selectionStart,u=i.slice(s);o.value=c+n+u,o.dispatchEvent(new Event("input")),e.hideMenu();var p=(c+n).length;o.setSelectionRange(p,p),o.focus(),e.choiceSelected.emit({choice:t,insertedAt:{start:r,end:r+n.length}})}),this.menuShown.emit()}},e.prototype.hideMenu=function(){this.menu&&(this.menu.component.destroy(),this.menuHidden.emit(),this.menu=void 0)},e.prototype.ngOnDestroy=function(){this.hideMenu()},o([r.Input(),i("design:type",Object)],e.prototype,"triggerCharacter",void 0),o([r.Input(),i("design:type",Object)],e.prototype,"searchRegexp",void 0),o([r.Input(),i("design:type",Object)],e.prototype,"menuComponent",void 0),o([r.Output(),i("design:type",Object)],e.prototype,"menuShown",void 0),o([r.Output(),i("design:type",Object)],e.prototype,"menuHidden",void 0),o([r.Output(),i("design:type",Object)],e.prototype,"choiceSelected",void 0),o([r.Input(),i("design:type",Function)],e.prototype,"findChoices",void 0),o([r.Input(),i("design:type",Function)],e.prototype,"getChoiceLabel",void 0),o([r.HostListener("keypress",["$event"]),i("design:type",Function),i("design:paramtypes",[KeyboardEvent]),i("design:returntype",void 0)],e.prototype,"onKeypress",null),o([r.HostListener("input",["$event.target.value"]),i("design:type",Function),i("design:paramtypes",[String]),i("design:returntype",void 0)],e.prototype,"onChange",null),o([r.HostListener("blur"),i("design:type",Function),i("design:paramtypes",[]),i("design:returntype",void 0)],e.prototype,"onBlur",null),e=o([r.Directive({selector:'textarea[mwlTextInputAutocomplete],input[type="text"][mwlTextInputAutocomplete]'}),i("design:paramtypes",[r.ComponentFactoryResolver,r.ViewContainerRef,r.Injector,r.ElementRef])],e)}();t.TextInputAutocompleteDirective=u},function(e,t){!function(){function t(e,t,r){if(!o)throw new Error("textarea-caret-position#getCaretCoordinates should only be called in a browser");var c=r&&r.debug||!1;if(c){var s=document.querySelector("#input-textarea-caret-position-mirror-div");s&&s.parentNode.removeChild(s)}var u=document.createElement("div");u.id="input-textarea-caret-position-mirror-div",document.body.appendChild(u);var p=u.style,a=window.getComputedStyle?getComputedStyle(e):e.currentStyle;p.whiteSpace="pre-wrap","INPUT"!==e.nodeName&&(p.wordWrap="break-word"),p.position="absolute",c||(p.visibility="hidden"),n.forEach(function(e){p[e]=a[e]}),i?e.scrollHeight>parseInt(a.height)&&(p.overflowY="scroll"):p.overflow="hidden",u.textContent=e.value.substring(0,t),"INPUT"===e.nodeName&&(u.textContent=u.textContent.replace(/\s/g," "));var h=document.createElement("span");h.textContent=e.value.substring(t)||".",u.appendChild(h);var l={top:h.offsetTop+parseInt(a.borderTopWidth),left:h.offsetLeft+parseInt(a.borderLeftWidth)};return c?h.style.backgroundColor="#aaa":document.body.removeChild(u),l}var n=["direction","boxSizing","width","height","overflowX","overflowY","borderTopWidth","borderRightWidth","borderBottomWidth","borderLeftWidth","borderStyle","paddingTop","paddingRight","paddingBottom","paddingLeft","fontStyle","fontVariant","fontWeight","fontStretch","fontSize","fontSizeAdjust","lineHeight","fontFamily","textAlign","textTransform","textIndent","textDecoration","letterSpacing","wordSpacing","tabSize","MozTabSize"],o="undefined"!=typeof window,i=o&&null!=window.mozInnerScreenX;void 0!==e&&void 0!==e.exports?e.exports=t:o&&(window.getCaretCoordinates=t)}()},function(e,t){e.exports=n},function(e,t){e.exports=o},function(e,t,n){"use strict";var o=this&&this.__decorate||function(e,t,n,o){var i,r=arguments.length,c=r<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,n):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)c=Reflect.decorate(e,t,n,o);else for(var s=e.length-1;s>=0;s--)(i=e[s])&&(c=(r<3?i(c):r>3?i(t,n,c):i(t,n))||c);return r>3&&c&&Object.defineProperty(t,n,c),c};Object.defineProperty(t,"__esModule",{value:!0});var i=n(0),r=function(){function e(){}return e=o([i.Component({selector:"mwl-text-input-autocomplete-container",styles:["\n    :host {\n      position: relative;\n      display: block;\n    }\n  "],template:"<ng-content></ng-content>"})],e)}();t.TextInputAutocompleteContainerComponent=r}])});
//# sourceMappingURL=angular-text-input-autocomplete.umd.min.js.map